diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/dhcp-server.h ns-3.47/src/internet-apps/model/dhcp-server.h
--- ns-3.46/src/internet-apps/model/dhcp-server.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/dhcp-server.h	2026-02-16 16:08:49.604230000 -0800
@@ -18,6 +18,7 @@
 #include "ns3/application.h"
 #include "ns3/ipv4-address.h"
 
+#include <limits>
 #include <map>
 
 namespace ns3
@@ -48,10 +49,10 @@
     /**
      * @brief Add a static entry to the pool.
      *
-     * @param chaddr The client chaddr.
-     * @param addr The address to handle to the client.
+     * @param macAddr The client MAC address.
+     * @param addr The IP address to handle to the client.
      */
-    void AddStaticDhcpEntry(Address chaddr, Ipv4Address addr);
+    void AddStaticDhcpEntry(Address macAddr, Ipv4Address addr);
 
   protected:
     void DoDispose() override;
@@ -97,21 +98,16 @@
     Ipv4Address m_gateway;     //!< The gateway address
 
     /// Leased address container - chaddr + IP addr / lease time
-    typedef std::map<Address, std::pair<Ipv4Address, uint32_t>> LeasedAddress;
-    /// Leased address iterator - chaddr + IP addr / lease time
-    typedef std::map<Address, std::pair<Ipv4Address, uint32_t>>::iterator LeasedAddressIter;
-    /// Leased address const iterator - chaddr + IP addr / lease time
-    typedef std::map<Address, std::pair<Ipv4Address, uint32_t>>::const_iterator LeasedAddressCIter;
+    using LeasedAddress = std::map<DhcpChaddr, std::pair<Ipv4Address, uint32_t>>;
 
     /// Expired address container - chaddr
-    typedef std::list<Address> ExpiredAddress;
-    /// Expired address iterator - chaddr
-    typedef std::list<Address>::iterator ExpiredAddressIter;
-    /// Expired address const iterator - chaddr
-    typedef std::list<Address>::const_iterator ExpiredAddressCIter;
+    using ExpiredAddress = std::list<DhcpChaddr>;
 
     /// Available address container - IP addr
-    typedef std::list<Ipv4Address> AvailableAddress;
+    using AvailableAddress = std::list<Ipv4Address>;
+
+    /// The maximum representable lease time means permanent lease.
+    static constexpr uint32_t PERMANENT_LEASE = std::numeric_limits<uint32_t>::max();
 
     LeasedAddress m_leasedAddresses;   //!< Leased address and their status (cache memory)
     ExpiredAddress m_expiredAddresses; //!< Expired addresses to be reused (chaddr of the clients)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/ping.cc ns-3.47/src/internet-apps/model/ping.cc
--- ns-3.46/src/internet-apps/model/ping.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/ping.cc	2026-02-16 16:08:49.604230000 -0800
@@ -585,8 +585,7 @@
         }
         else if (Ipv6Address::IsMatchingType(m_interfaceAddress))
         {
-            Inet6SocketAddress senderInet =
-                Inet6SocketAddress(Ipv6Address::ConvertFrom(m_interfaceAddress));
+            auto senderInet = Inet6SocketAddress(Ipv6Address::ConvertFrom(m_interfaceAddress));
             int status = m_socket->Bind(senderInet);
             NS_ASSERT_MSG(status == 0, "Failed to bind IPv6 socket");
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/model/v4traceroute.cc ns-3.47/src/internet-apps/model/v4traceroute.cc
--- ns-3.46/src/internet-apps/model/v4traceroute.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/model/v4traceroute.cc	2026-02-16 16:08:49.605229900 -0800
@@ -117,7 +117,7 @@
     NS_LOG_LOGIC("Application started");
     m_started = Simulator::Now();
 
-    NS_ABORT_MSG_IF(!m_remote.IsInitialized(), "'Remote' attribute not properly set");
+    NS_ABORT_MSG_IF(!m_remote.IsAny(), "'Remote' attribute not properly set");
 
     if (m_verbose)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/internet-apps/test/dhcp6-test.cc ns-3.47/src/internet-apps/test/dhcp6-test.cc
--- ns-3.46/src/internet-apps/test/dhcp6-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/internet-apps/test/dhcp6-test.cc	2026-02-16 16:08:49.605229900 -0800
@@ -13,7 +13,6 @@
 #include "ns3/data-rate.h"
 #include "ns3/dhcp6-header.h"
 #include "ns3/dhcp6-helper.h"
-#include "ns3/header-serialization-test.h"
 #include "ns3/internet-apps-module.h"
 #include "ns3/internet-module.h"
 #include "ns3/internet-stack-helper.h"
@@ -26,7 +25,6 @@
 #include "ns3/simple-net-device-helper.h"
 #include "ns3/simple-net-device.h"
 #include "ns3/simulator.h"
-#include "ns3/ssid.h"
 #include "ns3/test.h"
 #include "ns3/trace-helper.h"
 
@@ -181,6 +179,106 @@
  * @ingroup dhcp6-test
  * @ingroup tests
  *
+ * @brief DHCPv6 DUID tests
+ */
+class Dhcp6DuidTestCase : public TestCase
+{
+  public:
+    Dhcp6DuidTestCase();
+    ~Dhcp6DuidTestCase() override;
+
+  private:
+    void DoRun() override;
+};
+
+Dhcp6DuidTestCase::Dhcp6DuidTestCase()
+    : TestCase("Dhcp6 DUID test case ")
+{
+}
+
+Dhcp6DuidTestCase::~Dhcp6DuidTestCase()
+{
+}
+
+void
+Dhcp6DuidTestCase::DoRun()
+{
+    NodeContainer nodes;
+    nodes.Create(2);
+
+    SimpleNetDeviceHelper simpleNetDevice;
+    simpleNetDevice.SetChannelAttribute("Delay", TimeValue(MilliSeconds(2)));
+    simpleNetDevice.SetDeviceAttribute("DataRate", DataRateValue(DataRate("5Mbps")));
+    NetDeviceContainer devices = simpleNetDevice.Install(nodes);
+
+    InternetStackHelper internetv6;
+    internetv6.Install(nodes);
+
+    Ipv6AddressHelper ipv6;
+    ipv6.SetBase(Ipv6Address("2001:cafe::"), Ipv6Prefix(64));
+    Ipv6InterfaceContainer i = ipv6.AssignWithoutAddress(devices);
+
+    Dhcp6Helper dhcp6Helper;
+    ApplicationContainer dhcpClients = dhcp6Helper.InstallDhcp6Client(nodes);
+
+    // DUID-LL
+    {
+        Duid duidTest;
+        duidTest.InitializeLL(nodes.Get(1));
+        std::ostringstream buffer;
+        buffer << duidTest;
+        NS_TEST_ASSERT_MSG_EQ(duidTest.GetSerializedSize(), 10, "Unexpected DUID-LL length.");
+        std::string reference{"DUID-LL HWtype: 1 Identifier: 0x000000000002"};
+        NS_TEST_ASSERT_MSG_EQ(buffer.str(), reference, "Unexpected DUID-LL.");
+    }
+
+    // DUID-LLT
+    {
+        Duid duidTest;
+        duidTest.InitializeLLT(nodes.Get(1));
+        std::ostringstream buffer;
+        buffer << duidTest;
+        NS_TEST_ASSERT_MSG_EQ(duidTest.GetSerializedSize(), 14, "Unexpected DUID-LLT length.");
+        std::string reference{"DUID-LLT HWtype: 1 Time: 0 Identifier: 0x000000000002"};
+        NS_TEST_ASSERT_MSG_EQ(buffer.str(), reference, "Unexpected DUID-LLT.");
+    }
+
+    // DUID-EN
+    {
+        Duid duidTest;
+        std::vector<uint8_t> identifier(32);
+        std::iota(identifier.begin(), identifier.end(), 0);
+
+        duidTest.InitializeEN(0xf00dcafe, identifier);
+        std::ostringstream buffer;
+        buffer << duidTest;
+        NS_TEST_ASSERT_MSG_EQ(duidTest.GetSerializedSize(), 38, "Unexpected DUID-EN length.");
+        std::string reference{"DUID-EN EnNumber: 0xf00dcafe Identifier: "
+                              "0x000102030405060708090a0b0c0d0e0f101112131415161718191a1b1c1d1e1f"};
+        NS_TEST_ASSERT_MSG_EQ(buffer.str(), reference, "Unexpected DUID-EN.");
+    }
+
+    // DUID-UUID
+    {
+        Duid duidTest;
+        std::vector<uint8_t> identifier(16);
+        std::iota(identifier.begin(), identifier.end(), 0);
+
+        duidTest.InitializeUUID(identifier);
+        std::ostringstream buffer;
+        buffer << duidTest;
+        NS_TEST_ASSERT_MSG_EQ(duidTest.GetSerializedSize(), 18, "Unexpected DUID-UUID length.");
+        std::string reference{"DUID-UUID UUID: 0x000102030405060708090a0b0c0d0e0f"};
+        NS_TEST_ASSERT_MSG_EQ(buffer.str(), reference, "Unexpected DUID-UUID.");
+    }
+
+    Simulator::Destroy();
+}
+
+/**
+ * @ingroup dhcp6-test
+ * @ingroup tests
+ *
  * @brief DHCPv6 TestSuite
  */
 class Dhcp6TestSuite : public TestSuite
@@ -193,6 +291,7 @@
     : TestSuite("dhcp6", Type::UNIT)
 {
     AddTestCase(new Dhcp6TestCase, TestCase::Duration::QUICK);
+    AddTestCase(new Dhcp6DuidTestCase, TestCase::Duration::QUICK);
 }
 
 static Dhcp6TestSuite dhcp6TestSuite; //!< Static variable for test initialization
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/CMakeLists.txt ns-3.47/src/lr-wpan/CMakeLists.txt
--- ns-3.46/src/lr-wpan/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/CMakeLists.txt	2026-02-16 16:08:49.627230000 -0800
@@ -41,7 +41,7 @@
     test/lr-wpan-ed-test.cc
     test/lr-wpan-error-model-test.cc
     test/lr-wpan-packet-test.cc
-    test/lr-wpan-pd-plme-sap-test.cc
+    test/lr-wpan-phy-test.cc
     test/lr-wpan-spectrum-value-helper-test.cc
     test/lr-wpan-ifs-test.cc
     test/lr-wpan-slotted-csmaca-test.cc
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/examples/lr-wpan-active-scan.cc ns-3.47/src/lr-wpan/examples/lr-wpan-active-scan.cc
--- ns-3.46/src/lr-wpan/examples/lr-wpan-active-scan.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/examples/lr-wpan-active-scan.cc	2026-02-16 16:08:49.628230000 -0800
@@ -79,6 +79,10 @@
 int
 main(int argc, char* argv[])
 {
+    // CommandLine options required by PyViz visualizer
+    CommandLine cmd(__FILE__);
+    cmd.Parse(argc, argv);
+
     LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
 
     // Create 2 PAN coordinator nodes, and 1 end device
@@ -115,17 +119,17 @@
     Ptr<ConstantPositionMobilityModel> coord1Mobility =
         CreateObject<ConstantPositionMobilityModel>();
     coord1Mobility->SetPosition(Vector(0, 0, 0));
-    coord1NetDevice->GetPhy()->SetMobility(coord1Mobility);
+    coord1->AggregateObject(coord1Mobility);
 
     Ptr<ConstantPositionMobilityModel> endNodeMobility =
         CreateObject<ConstantPositionMobilityModel>();
     endNodeMobility->SetPosition(Vector(100, 0, 0));
-    endNodeNetDevice->GetPhy()->SetMobility(endNodeMobility);
+    endNode->AggregateObject(endNodeMobility);
 
     Ptr<ConstantPositionMobilityModel> coord2Mobility =
         CreateObject<ConstantPositionMobilityModel>();
     coord2Mobility->SetPosition(Vector(206, 0, 0));
-    coord2NetDevice->GetPhy()->SetMobility(coord2Mobility);
+    coord2->AggregateObject(coord2Mobility);
 
     // MAC layer Callbacks hooks
     endNodeNetDevice->GetMac()->SetMlmeScanConfirmCallback(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/examples/lr-wpan-bootstrap.cc ns-3.47/src/lr-wpan/examples/lr-wpan-bootstrap.cc
--- ns-3.46/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/examples/lr-wpan-bootstrap.cc	2026-02-16 16:08:49.628230000 -0800
@@ -328,6 +328,10 @@
 int
 main(int argc, char* argv[])
 {
+    // CommandLine options required by PyViz visualizer
+    CommandLine cmd(__FILE__);
+    cmd.Parse(argc, argv);
+
     LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC | LOG_PREFIX_NODE));
 
     nodes.Create(100);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/examples/lr-wpan-data.cc ns-3.47/src/lr-wpan/examples/lr-wpan-data.cc
--- ns-3.46/src/lr-wpan/examples/lr-wpan-data.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/examples/lr-wpan-data.cc	2026-02-16 16:08:49.628230000 -0800
@@ -36,7 +36,9 @@
 static void
 DataIndication(McpsDataIndicationParams params, Ptr<Packet> p)
 {
-    NS_LOG_UNCOND("Received packet of size " << p->GetSize());
+    std::cout << "Received packet of size: " << p->GetSize()
+              << " | LQI: " << static_cast<uint16_t>(params.m_mpduLinkQuality)
+              << " | RSSI: " << static_cast<int16_t>(params.m_rssi) << " dBm\n";
 }
 
 /**
@@ -46,7 +48,7 @@
 static void
 DataConfirm(McpsDataConfirmParams params)
 {
-    NS_LOG_UNCOND("LrWpanMcpsDataConfirmStatus = " << static_cast<uint16_t>(params.m_status));
+    std::cout << "LrWpanMcpsDataConfirmStatus = " << static_cast<uint16_t>(params.m_status) << "\n";
 }
 
 /**
@@ -62,9 +64,9 @@
                         PhyEnumeration oldState,
                         PhyEnumeration newState)
 {
-    NS_LOG_UNCOND(context << " state change at " << now.As(Time::S) << " from "
-                          << LrWpanHelper::LrWpanPhyEnumerationPrinter(oldState) << " to "
-                          << LrWpanHelper::LrWpanPhyEnumerationPrinter(newState));
+    std::cout << context << " state change at " << now.As(Time::S) << " from "
+              << LrWpanHelper::LrWpanPhyEnumerationPrinter(oldState) << " to "
+              << LrWpanHelper::LrWpanPhyEnumerationPrinter(newState) << "\n";
 }
 
 int
@@ -73,6 +75,7 @@
     bool verbose = false;
     bool extended = false;
 
+    // CommandLine options are also required by PyViz visualizer
     CommandLine cmd(__FILE__);
 
     cmd.AddValue("verbose", "turn on all log components", verbose);
@@ -156,12 +159,12 @@
     Ptr<ConstantPositionMobilityModel> sender0Mobility =
         CreateObject<ConstantPositionMobilityModel>();
     sender0Mobility->SetPosition(Vector(0, 0, 0));
-    dev0->GetPhy()->SetMobility(sender0Mobility);
+    n0->AggregateObject(sender0Mobility);
+
     Ptr<ConstantPositionMobilityModel> sender1Mobility =
         CreateObject<ConstantPositionMobilityModel>();
-    // Configure position 10 m distance
     sender1Mobility->SetPosition(Vector(0, 10, 0));
-    dev1->GetPhy()->SetMobility(sender1Mobility);
+    n1->AggregateObject(sender1Mobility);
 
     McpsDataConfirmCallback cb0;
     cb0 = MakeCallback(&DataConfirm);
@@ -199,6 +202,7 @@
     }
     params.m_msduHandle = 0;
     params.m_txOptions = TX_OPTION_ACK;
+
     //  dev0->GetMac ()->McpsDataRequest (params, p0);
     Simulator::ScheduleWithContext(1,
                                    Seconds(0),
@@ -224,6 +228,7 @@
                                    params,
                                    p2);
 
+    Simulator::Stop(Seconds(10));
     Simulator::Run();
 
     Simulator::Destroy();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc ns-3.47/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc
--- ns-3.46/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/examples/lr-wpan-error-distance-plot.cc	2026-02-16 16:08:49.628230000 -0800
@@ -96,10 +96,12 @@
     cmd.Parse(argc, argv);
 
     os << "Packet (MSDU) size = " << packetSize << " bytes; tx power = " << txPower
-       << " dBm; channel = " << channelNumber << "; Rx sensitivity = " << rxSensitivity << " dBm";
+       << " dBm; channel = " << channelNumber;
 
     Gnuplot psrplot = Gnuplot("802.15.4-psr-distance.eps");
-    Gnuplot2dDataset psrdataset("802.15.4-psr-vs-distance");
+    std::ostringstream legendLabel;
+    legendLabel << rxSensitivity << " dBm";
+    Gnuplot2dDataset psrdataset(legendLabel.str());
 
     Ptr<Node> n0 = CreateObject<Node>();
     Ptr<Node> n1 = CreateObject<Node>();
@@ -130,6 +132,8 @@
     cb0 = MakeCallback(&LrWpanErrorDistanceCallback);
     dev1->GetMac()->SetMcpsDataIndicationCallback(cb0);
 
+    std::cout << "Generating distance plot, this might take a few seconds...\n";
+
     McpsDataRequestParams params;
     params.m_srcAddrMode = SHORT_ADDR;
     params.m_dstAddrMode = SHORT_ADDR;
@@ -160,15 +164,19 @@
 
     psrplot.SetTitle(os.str());
     psrplot.SetTerminal("postscript eps color enh \"Times-BoldItalic\"");
-    psrplot.SetLegend("distance (m)", "Packet Success Rate (PSR)");
+    psrplot.SetLegend("Distance (m)", "Packet Success Rate (PSR)");
     psrplot.SetExtra("set xrange [0:200]\n\
                       set yrange [0:1]\n\
                       set grid\n\
+                      set xtics 20\n\
+                      set key inside right top vertical Right noreverse enhanced autotitles nobox\n\
+                      set key title '{/:Bold Rx Sensitivity}'\n\
                       set style line 1 linewidth 5\n\
                       set style increment user");
     psrplot.GenerateOutput(berfile);
     berfile.close();
 
     Simulator::Destroy();
+    std::cout << "Distance plot generated\n";
     return 0;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/examples/lr-wpan-orphan-scan.cc ns-3.47/src/lr-wpan/examples/lr-wpan-orphan-scan.cc
--- ns-3.46/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/examples/lr-wpan-orphan-scan.cc	2026-02-16 16:08:49.628230000 -0800
@@ -109,6 +109,10 @@
 int
 main(int argc, char* argv[])
 {
+    // CommandLine options required by PyViz visualizer
+    CommandLine cmd(__FILE__);
+    cmd.Parse(argc, argv);
+
     LogComponentEnableAll(LogLevel(LOG_PREFIX_TIME | LOG_PREFIX_FUNC));
 
     // Create 2 PAN coordinator nodes, and 1 end device
@@ -146,12 +150,12 @@
     Ptr<ConstantPositionMobilityModel> coord1Mobility =
         CreateObject<ConstantPositionMobilityModel>();
     coord1Mobility->SetPosition(Vector(0, 0, 0));
-    coord1NetDevice->GetPhy()->SetMobility(coord1Mobility);
+    coord1->AggregateObject(coord1Mobility);
 
     Ptr<ConstantPositionMobilityModel> endNodeMobility =
         CreateObject<ConstantPositionMobilityModel>();
     endNodeMobility->SetPosition(Vector(100, 0, 0));
-    endNodeNetDevice->GetPhy()->SetMobility(endNodeMobility);
+    endNode->AggregateObject(endNodeMobility);
 
     // MAC layer Callbacks hooks
     endNodeNetDevice->GetMac()->SetMlmeScanConfirmCallback(
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/examples/lr-wpan-phy-test.cc ns-3.47/src/lr-wpan/examples/lr-wpan-phy-test.cc
--- ns-3.46/src/lr-wpan/examples/lr-wpan-phy-test.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/examples/lr-wpan-phy-test.cc	2026-02-16 16:08:49.629230000 -0800
@@ -33,12 +33,13 @@
  * @param psduLength PSDU length
  * @param p packet
  * @param lqi link quality indication
+ * @param rssi received signal strength indicator
  */
 void
-ReceivePdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi)
+ReceivePdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi, int8_t rssi)
 {
-    NS_LOG_UNCOND("At: " << Simulator::Now() << " Received frame size: " << psduLength
-                         << " LQI: " << (uint16_t)lqi);
+    NS_LOG_UNCOND("At: " << Simulator::Now() << " Received frame size: " << psduLength << " LQI: "
+                         << static_cast<int16_t>(lqi) << " RSSI: " << static_cast<int16_t>(rssi));
 }
 
 /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/model/lr-wpan-interference-helper.h ns-3.47/src/lr-wpan/model/lr-wpan-interference-helper.h
--- ns-3.46/src/lr-wpan/model/lr-wpan-interference-helper.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/model/lr-wpan-interference-helper.h	2026-02-16 16:08:49.629230000 -0800
@@ -40,6 +40,10 @@
 
     ~LrWpanInterferenceHelper();
 
+    // Delete copy constructor and assignment operator to avoid misuse
+    LrWpanInterferenceHelper(const LrWpanInterferenceHelper&) = delete;
+    LrWpanInterferenceHelper& operator=(const LrWpanInterferenceHelper&) = delete;
+
     /**
      * Add the given signal to the set of accumulated signals. Never add the same
      * signal more than once. The SpectrumModels of the signal and the one used
@@ -80,16 +84,6 @@
     Ptr<const SpectrumModel> GetSpectrumModel() const;
 
   private:
-    // Disable implicit copy constructors
-    /**
-     * @brief Copy constructor - defined and not implemented.
-     */
-    LrWpanInterferenceHelper(const LrWpanInterferenceHelper&);
-    /**
-     * @brief Copy constructor - defined and not implemented.
-     * @returns
-     */
-    LrWpanInterferenceHelper& operator=(const LrWpanInterferenceHelper&);
     /**
      * The helpers SpectrumModel.
      */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/model/lr-wpan-mac-base.h ns-3.47/src/lr-wpan/model/lr-wpan-mac-base.h
--- ns-3.46/src/lr-wpan/model/lr-wpan-mac-base.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/model/lr-wpan-mac-base.h	2026-02-16 16:08:49.629230000 -0800
@@ -330,7 +330,9 @@
 /**
  * @ingroup lr-wpan
  *
- * MCPS-DATA.indication params. See 7.1.1.3
+ * MCPS-DATA.indication params.
+ * See IEEE 802.15.4-2011, Section 7.1.1.1
+ * See IEEE 802.15.4-2015, Section 8.3.3 (e.g., RSSI)
  */
 struct McpsDataIndicationParams
 {
@@ -343,6 +345,9 @@
     Mac16Address m_dstAddr;            //!< Destination address
     Mac64Address m_dstExtAddr;         //!< Destination extended address
     uint8_t m_mpduLinkQuality{0};      //!< LQI value measured during reception of the MPDU
+    int8_t m_rssi{-128};               //!< RSSI value measured after the preamble
+                                       //!< during the reception of the packet SFD.
+                                       //!< (IEEE 802.15.4-2015 onwards)
     uint8_t m_dsn{0};                  //!< The DSN of the received data frame
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/src/lr-wpan/model/lr-wpan-mac.cc ns-3.47/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.46/src/lr-wpan/model/lr-wpan-mac.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/src/lr-wpan/model/lr-wpan-mac.cc	2026-02-16 16:08:49.630230000 -0800
@@ -242,8 +242,6 @@
     m_maxIndTxQueueSize = m_indTxQueue.max_size();
 
     m_uniformVar = CreateObject<UniformRandomVariable>();
-    m_macDsn = SequenceNumber8(m_uniformVar->GetInteger(0, 255));
-    m_macBsn = SequenceNumber8(m_uniformVar->GetInteger(0, 255));
     m_macBeaconPayload = {};
     m_macBeaconPayloadLength = 0;
     m_shortAddress = Mac16Address("FF:FF"); // FF:FF = The address is not assigned.
@@ -259,6 +257,8 @@
 {
     NS_LOG_FUNCTION(this);
 
+    m_macDsn = SequenceNumber8(m_uniformVar->GetInteger(0, 255));
+    m_macBsn = SequenceNumber8(m_uniformVar->GetInteger(0, 255));
     if (m_macRxOnWhenIdle)
     {
         m_phy->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_RX_ON);
@@ -564,7 +564,7 @@
         }
         p->AddTrailer(macTrailer);
 
-        Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+        auto txQElement = std::make_shared<TxQueueElement>();
         txQElement->txQMsduHandle = params.m_msduHandle;
         txQElement->txQPkt = p;
         EnqueueTxQElement(txQElement);
@@ -847,7 +847,7 @@
 
     commandPacket->AddTrailer(macTrailer);
 
-    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    auto txQElement = std::make_shared<TxQueueElement>();
     txQElement->txQPkt = commandPacket;
     EnqueueTxQElement(txQElement);
     CheckQueue();
@@ -1030,6 +1030,7 @@
 
 void
 LrWpanMac::ReceiveInPromiscuousMode(uint8_t lqi,
+                                    int8_t rssi,
                                     const LrWpanMacHeader& receivedMacHdr,
                                     Ptr<Packet> p)
 {
@@ -1046,6 +1047,7 @@
         params.m_mpduLinkQuality = lqi;
         params.m_srcPanId = receivedMacHdr.GetSrcPanId();
         params.m_srcAddrMode = receivedMacHdr.GetSrcAddrMode();
+        params.m_rssi = rssi;
 
         switch (params.m_srcAddrMode)
         {
@@ -1150,7 +1152,7 @@
         // Beacon as a result of a beacon request
         // The beacon shall be transmitted using CSMA/CA
         // IEEE 802.15.4-2011 (Section 5.1.2.1.2)
-        Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+        auto txQElement = std::make_shared<TxQueueElement>();
         txQElement->txQPkt = beaconPacket;
         EnqueueTxQElement(txQElement);
         CheckQueue();
@@ -1193,7 +1195,7 @@
 
     commandPacket->AddTrailer(macTrailer);
 
-    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    auto txQElement = std::make_shared<TxQueueElement>();
     txQElement->txQPkt = commandPacket;
     EnqueueTxQElement(txQElement);
     CheckQueue();
@@ -1234,7 +1236,7 @@
 
     commandPacket->AddTrailer(macTrailer);
 
-    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    auto txQElement = std::make_shared<TxQueueElement>();
     txQElement->txQPkt = commandPacket;
     EnqueueTxQElement(txQElement);
     CheckQueue();
@@ -1283,7 +1285,7 @@
 
     commandPacket->AddTrailer(macTrailer);
 
-    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    auto txQElement = std::make_shared<TxQueueElement>();
     txQElement->txQPkt = commandPacket;
     EnqueueTxQElement(txQElement);
     CheckQueue();
@@ -1342,7 +1344,7 @@
     commandPacket->AddTrailer(macTrailer);
 
     // Set the Command packet to be transmitted
-    Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+    auto txQElement = std::make_shared<TxQueueElement>();
     txQElement->txQPkt = commandPacket;
     EnqueueTxQElement(txQElement);
     CheckQueue();
@@ -1358,12 +1360,12 @@
 
     NS_ASSERT(receivedMacPayload.GetCommandFrameType() == CommandPayloadHeader::DATA_REQ);
 
-    Ptr<IndTxQueueElement> indTxQElement = Create<IndTxQueueElement>();
+    auto indTxQElement = std::make_shared<IndTxQueueElement>();
     bool elementFound;
     elementFound = DequeueInd(receivedMacHdr.GetExtSrcAddr(), indTxQElement);
     if (elementFound)
     {
-        Ptr<TxQueueElement> txQElement = Create<TxQueueElement>();
+        auto txQElement = std::make_shared<TxQueueElement>();
         txQElement->txQPkt = indTxQElement->txQPkt;
         m_txQueue.emplace_back(txQElement);
     }
@@ -2077,7 +2079,10 @@
 }
 
 void
-LrWpanMac::ReceiveData(uint8_t lqi, const LrWpanMacHeader& receivedMacHdr, Ptr<Packet> p)
+LrWpanMac::ReceiveData(uint8_t lqi,
+                       int8_t rssi,
+                       const LrWpanMacHeader& receivedMacHdr,
+                       Ptr<Packet> p)
 {
     NS_LOG_FUNCTION(this << lqi << p);
 
@@ -2090,6 +2095,7 @@
         params.m_mpduLinkQuality = lqi;
         params.m_srcPanId = receivedMacHdr.GetSrcPanId();
         params.m_srcAddrMode = receivedMacHdr.GetSrcAddrMode();
+        params.m_rssi = rssi;
 
         switch (params.m_srcAddrMode)
         {
@@ -2258,7 +2264,7 @@
         // Receive ACK to data packet
         if (!m_mcpsDataConfirmCallback.IsNull())
         {
-            Ptr<TxQueueElement> txQElement = m_txQueue.front();
+            std::shared_ptr<TxQueueElement> txQElement = m_txQueue.front();
             McpsDataConfirmParams confirmParams;
             confirmParams.m_msduHandle = txQElement->txQMsduHandle;
             confirmParams.m_status = MacStatus::SUCCESS;
@@ -2316,7 +2322,7 @@
             // check MAC is not in a IFS
             if (!m_ifsEvent.IsPending())
             {
-                Ptr<TxQueueElement> txQElement = m_txQueue.front();
+                std::shared_ptr<TxQueueElement> txQElement = m_txQueue.front();
                 m_txPkt = txQElement->txQPkt;
 
                 m_setMacState =
@@ -2392,7 +2398,7 @@
 }
 
 void
-LrWpanMac::PdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi)
+LrWpanMac::PdDataIndication(uint32_t psduLength, Ptr<Packet> p, uint8_t lqi, int8_t rssi)
 {
     NS_ASSERT(m_macState == MAC_IDLE || m_macState == MAC_ACK_PENDING || m_macState == MAC_CSMA);
     NS_LOG_FUNCTION(this << psduLength << p << (uint16_t)lqi);
@@ -2443,7 +2449,7 @@
     if (m_macPromiscuousMode)
     {
         PrintReceivedPacket(receivedMacHdr);
-        ReceiveInPromiscuousMode(lqi, receivedMacHdr, p);
+        ReceiveInPromiscuousMode(lqi, rssi, receivedMacHdr, p);
         return;
     }
 
@@ -2646,7 +2652,7 @@
     }
     else if (receivedMacHdr.IsData())
     {
-        ReceiveData(lqi, receivedMacHdr, p);
+        ReceiveData(lqi, rssi, receivedMacHdr, p);
     }
     else if (receivedMacHdr.IsAcknowledgment() && m_txPkt && m_macState == MAC_ACK_PENDING)
     {
@@ -2684,7 +2690,7 @@
 }
 
 void
-LrWpanMac::EnqueueTxQElement(Ptr<TxQueueElement> txQElement)
+LrWpanMac::EnqueueTxQElement(std::shared_ptr<TxQueueElement> txQElement)
 {
     if (m_txQueue.size() < m_maxTxQueueSize)
     {
@@ -2708,7 +2714,7 @@
 void
 LrWpanMac::RemoveFirstTxQElement()
 {
-    Ptr<TxQueueElement> txQElement = m_txQueue.front();
+    std::shared_ptr<TxQueueElement> txQElement = m_txQueue.front();
     Ptr<const Packet> p = txQElement->txQPkt;
     m_numCsmacaRetry += m_csmaCa->GetNB() + 1;
 
@@ -2862,7 +2868,7 @@
         {
             // Maximum number of retransmissions has been reached.
             // remove the copy of the DATA packet that was just sent
-            Ptr<TxQueueElement> txQElement = m_txQueue.front();
+            std::shared_ptr<TxQueueElement> txQElement = m_txQueue.front();
             m_macTxDropTrace(txQElement->txQPkt);
             if (!m_mcpsDataConfirmCallback.IsNull())
             {
@@ -2888,7 +2894,7 @@
 void
 LrWpanMac::EnqueueInd(Ptr<Packet> p)
 {
-    Ptr<IndTxQueueElement> indTxQElement = Create<IndTxQueueElement>();
+    auto indTxQElement = std::make_shared<IndTxQueueElement>();
     LrWpanMacHeader peekedMacHdr;
     p->PeekHeader(peekedMacHdr);
 
@@ -2952,7 +2958,7 @@
 }
 
 bool
-LrWpanMac::DequeueInd(Mac64Address dst, Ptr<IndTxQueueElement> entry)
+LrWpanMac::DequeueInd(Mac64Address dst, std::shared_ptr<IndTxQueueElement> entry)
 {
     PurgeInd();
 
@@ -3027,7 +3033,7 @@
        << "    Frame type    |"
        << "    Expire time\n";
 
-    for (auto transaction : m_indTxQueue)
+    for (const auto& transaction : m_indTxQueue)
     {
         transaction->txQPkt->PeekHeader(peekedMacHdr);
         os << transaction->dstExtAddress << "           "
@@ -3062,7 +3068,7 @@
        << "    Dst PAN id    |"
        << "    Frame type    |\n";
 
-    for (auto transaction : m_txQueue)
+    for (const auto& transaction : m_txQueue)
     {
         transaction->txQPkt->PeekHeader(peekedMacHdr);
 
@@ -3251,7 +3257,7 @@
                 {
                     McpsDataConfirmParams confirmParams;
                     NS_ASSERT_MSG(!m_txQueue.empty(), "TxQsize = 0");
-                    Ptr<TxQueueElement> txQElement = m_txQueue.front();
+                    std::shared_ptr<TxQueueElement> txQElement = m_txQueue.front();
                     confirmParams.m_msduHandle = txQElement->txQMsduHandle;
                     confirmParams.m_status = MacStatus::SUCCESS;
                     m_mcpsDataConfirmCallback(confirmParams);
@@ -3356,7 +3362,7 @@
         if (!macHdr.IsAcknowledgment())
         {
             NS_ASSERT_MSG(!m_txQueue.empty(), "TxQsize = 0");
-            Ptr<TxQueueElement> txQElement = m_txQueue.front();
+            std::shared_ptr<TxQueueElement> txQElement = m_txQueue.front();
             m_macTxDropTrace(txQElement->txQPkt);
             if (!m_mcpsDataConfirmCallback.IsNull())
             {
@@ -3425,7 +3431,7 @@
 void
 LrWpanMac::PlmeSetTRXStateConfirm(PhyEnumeration status)
 {
-    NS_LOG_FUNCTION(this << status);
+    NS_LOG_FUNCTION(this << status << m_macState);
 
     if (m_macState == MAC_SENDING &&
         (status == IEEE_802_15_4_PHY_TX_ON || status == IEEE_802_15_4_PHY_SUCCESS))
